module AssetZipImportable
  module ImportarOperatable
    extend ActiveSupport::Concern

    module ClassMethods
      def importar(importar_class, options = {})
        define_method :importar_class do
          importar_class
        end

        define_method :after_create_redirect_path_method do
          options[:after_create_redirect_path_method]
        end
      end
    end

    def index
      @imports = importar_class.order('created_at DESC').page(params[:page]).per(20)
      @new_import = importar_class.new
    end

    def create
      @importar = importar_class.new(importar_params)
      message = if @importar.save
        ImportWorker.perform_async(@importar.class.name, @importar.id)
        { notice: 'インポートを開始しました' }
      else
        { alert: 'インポートに失敗しました' }
      end
      redirect_to send(after_create_redirect_path_method), message
    end

    private
      def importar_params
        params.require(importar_class.name.underscore).permit(:zip)
      end
  end
end
