module AssetZipImportable
  module Importable
    module Completions
      def complete!
        self.completed_at = Time.now
        save!
      end

      def completed?
        !!completed_at
      end

      def increment_completed_number!
        self.completed_number ||= 0
        self.completed_number += 1
        if completed_number == self.total_number
          complete!
        else
          save!
        end
      end

      def progress
        return 0 if completed_number.nil?
        (completed_number.to_f / total_number.to_f * 100).round
      end
    end
  end
end
