module AssetZipImportable
  module Importable
    module Extractions
      ACCEPT_FILE_TYPES = %w(JPEG GIF PNG PDF)

      def download
        FileUtils.mkdir_p(zip_file_dir)
        File.open(zip_file, 'wb') do |opened_zip_file|
          opened_zip_file << uploaded_zip_file.read
        end
      end

      def extract
        return unless FileTest.exist?(zip_file)

        Zip::ZipFile.open(zip_file) do |opened_zip_file|
          opened_zip_file.each do |entry|
            file_path = zip_file_dir + '/' + entry.to_s

            FileUtils::mkdir_p(File.dirname(file_path))
            opened_zip_file.extract(entry, file_path) { true }

            if accept_file_type?(file_path)
              self.total_number ||= 0
              self.total_number += 1
            else
              unless FileTest.directory?(file_path)
                File.delete(file_path)
              end
            end
          end
        end
        save!
      end

      def accept_file_type?(file_path)
        ACCEPT_FILE_TYPES.include?(_file_type(file_path))
      end

      private
        def _file_type(file_path)
          `file -b #{ file_path }`.split(' ').first
        end
    end
  end
end
