module AssetZipImportable
  module Importable
    module FilePaths
      def zip_file
        Rails.root.join('tmp', model_class.name.underscore.pluralize, id.to_s, read_attribute(:zip))
      end

      def zip_file_dir
        File.dirname(zip_file)
      end

      def uploaded_zip_file
        case zip.file
        when CarrierWave::SanitizedFile
          open(zip.file.path)
        when CarrierWave::Storage::Fog::File
          open(zip.file.try(:authenticated_url))
        end
      end

      def extract_file_paths
        file_dir = Dir.glob(zip_file_dir + '/*').detect{ |path|
          File.directory?(path) && !path.match(/__MACOSX/)
        }
        Dir.glob(file_dir + '/*.*')
      end

      def extract_files
        extract_file_paths.inject([]){ |result, path|
          result << File.open(path)
          result
        }
      end
    end
  end
end
