module AssetZipImportable
  class ImportWorker
    include Sidekiq::Worker

    def perform(model_name, id)
      model_name.constantize.find(id).import!(
        success: -> (resource) {
          log 'SAVED', resource.inspect
        },
        error: -> (resource) {
          log 'FALED', "#{ resource.inspect }, #{ resource.errors.full_messages.inspect }"
        }
      )
    rescue => e
      log 'ERROR', e.inspect
    end

    private
      def log(type, text)
        Rails.logger.info "[#{ type }][#{ self.class.name }] #{ text }"
      end
  end
end
