require 'rails/generators'
require 'rails/generators/migration'
require 'rails/generators/active_record'

class AssetZipImportarGenerator < Rails::Generators::Base
  include Rails::Generators::Migration
  extend ActiveRecord::Generators::Migration

  source_root File.expand_path('../templates', __FILE__)

  argument :model_name, type: :string
  argument :asset_attribute_name, type: :string

  def generate_asset_zip_importar
    template "importar_model.rb.erb", "app/models/#{ importar_name }.rb"
    migration_template "migration.rb.erb", "db/migrate/create_#{ importars_name }.rb"
  end

  def importar_model_name
    importar_name.camelize
  end

  def importar_name
    "import_#{ model_name }_#{ asset_attribute_name }"
  end

  def importars_name
    importar_name.pluralize
  end

  class << self
    def next_migration_number(path)
      ActiveRecord::Generators::Base.next_migration_number(path)
    end
  end
end
